// $Id$
package org.objectstyle.dataService.struts;

import org.apache.struts.action.ActionForm;

/**
 * TODO provide class description
 * @author cris.daniluk
 * @version $LastChangedRevision$
 */
public class AbstractDataServiceActionForm extends ActionForm {
    /**
     * Request parameter <code>objectType</code>, which should correspond to
     * a key in the map returned by <see>getObjectMap</code>.
     * 
     * Note that this parameter is mutually exclusive with query. Both should
     * not be used.
     */
    protected String objectType;

    /**
     * Request parameter <code>expression</code>, which specifies an optional
     * expression to be run with the query.
     */
    protected String expression;

    /**
     * Request parameter <code>query</code>, which specifies a named Cayenne
     * query that should be used to retrieve results. Note that the data service
     * will not alter the refetch or caching properties of the query.
     * 
     * Note that this parameter is mutually exclusive with objectType. Both
     * should not be used.
     */
    protected String query;

    /**
     * Request parameter <code>filterInMemory</code>, which specifies whether
     * or not the expression (if provided) should be executed in memory or at
     * the database. By default, this will be true if the query is named (to
     * ensure caching), or false if the query is not named.
     */
    protected String filterInMemory;

    /**
     * Request parameter <code>ordering</code>, which specifies the sort
     * ordering of results. If filterInMemory is set to true, the results will
     * also be ordered in memory. The sort order will match the query or
     * database default if not specified. The ordering should be provided as a
     * comma separated list of field names (from the ObjEntity, not from the
     * DbEntity). To specify ascending or descending, prefix the field name with
     * a + or -. The default order is ascending.
     */
    protected String ordering;

    public String getExpression() {
        return expression;
    }

    public void setExpression(String expression) {
        this.expression = expression;
    }

    public String getFilterInMemory() {
        return filterInMemory;
    }

    public void setFilterInMemory(String filterInMemory) {
        this.filterInMemory = filterInMemory;
    }

    public String getObjectType() {
        return objectType;
    }

    public void setObjectType(String objectType) {
        this.objectType = objectType;
    }

    public String getOrdering() {
        return ordering;
    }

    public void setOrdering(String ordering) {
        this.ordering = ordering;
    }

    public String getQuery() {
        return query;
    }

    public void setQuery(String query) {
        this.query = query;
    }
    
}
